﻿
; https://usbtor.ru/viewtopic.php?p=76839#76839
; https://www.purebasic.fr/english/viewtopic.php?p=153623#p153623

;Чтение размера RAW диска
Structure DISK_GEOMETRY
	Cylinders.q
	MediaType.l
	TracksPerCylinder.l
	SectorsPerTrack.l
	BytesPerSector.l
EndStructure

Structure DISK_GEOMETRY_EX Extends DISK_GEOMETRY
	DiskSize.q
	byte.b[1]
EndStructure

#FILE_ANY_ACCESS = 0
#METHOD_BUFFERED = 0
#IOCTL_DISK_BASE = 7

Macro CTL_CODE(DeviceType, Function, Method, Access)
	((DeviceType)<<16)|((Access)<<14)|((Function)<<2)|(Method)
EndMacro

#IOCTL_DISK_GET_DRIVE_GEOMETRY_EX = CTL_CODE(#IOCTL_DISK_BASE, $28, #METHOD_BUFFERED, #FILE_ANY_ACCESS)

Procedure.q _GetDriveSize(Drive.s)
	Protected device.l, bytes.l, os.OSVERSIONINFO, disk.DISK_GEOMETRY_EX
	os\dwOSVersionInfoSize = SizeOf(OSVERSIONINFO)
	device = CreateFile_("\\.\" + Drive, #GENERIC_READ|#GENERIC_WRITE, #FILE_SHARE_READ|#FILE_SHARE_WRITE, 0, #OPEN_EXISTING, 0, 0)
	If device <> #INVALID_HANDLE_VALUE
		DeviceIoControl_(device, #IOCTL_DISK_GET_DRIVE_GEOMETRY_EX, 0, 0, @disk, SizeOf(disk), @bytes, 0)
		CloseHandle_(device)
	EndIf
	ProcedureReturn disk\Disksize
EndProcedure

Procedure.s ComboListDrive(Drive2$)
	Protected.l Serial, type, i
	Protected.s Lfwrk, FileSystem, VolName, r = Chr(10)
	Protected.q total_bytes
	Lfwrk=Drive2$+":\"
	type =GetDriveType_(Lfwrk)
	FileSystem = Space(256)
	VolName= Space(256)
	;   If Lfwrk = "H:\"
	;     Debug type
	;   EndIf
	Select type
		Case #DRIVE_REMOVABLE
			Drive2$+":" + r + "[" + DriveGetNumber(Drive2$ + ":") + "]" + r + "Rem  "
		Case #DRIVE_FIXED
			Drive2$+":" + r + "[" + DriveGetNumber(Drive2$ + ":") + "]" + r + "Fixed"
		Case #DRIVE_REMOTE, #DRIVE_CDROM, #DRIVE_RAMDISK
			ProcedureReturn "-"
		Case #DRIVE_NO_ROOT_DIR
			ProcedureReturn Drive2$+":" + r + "[" + DriveGetNumber(Drive2$ + ":") + "]" + r + "No_Root_Dir"
		Case #DRIVE_UNKNOWN
			ProcedureReturn Drive2$+":" + r + "[" + DriveGetNumber(Drive2$ + ":") + "]" + r + "Unknown"
		Default
			ProcedureReturn Drive2$+":" + r + "[" + DriveGetNumber(Drive2$ + ":") + "]" + r + "---"
	EndSelect
	If GetVolumeInformation_(@Lfwrk, @VolName, 255, @Serial, 0, 0, @FileSystem, 255)
		Drive2$ + r + VolName + r + FileSystem
	Else
		Drive2$ + r + "---" + r + "---"
	EndIf
	;     Drive2$ = DriveGetNumber(Left(Drive2$,1) + ":") + "  " + Drive2$
	If (GetDiskFreeSpaceEx_(Lfwrk, 0, @total_bytes, 0))
		;      Drive2$ + "  "+  Str(total_bytes/1048576)+ " Мб"
		Drive2$ + r + FormatSizeDisk(total_bytes)
	Else
		Drive2$ + r + FormatSizeDisk(_GetDriveSize(Left(Drive2$,1) + ":"))
	EndIf
	ProcedureReturn Drive2$
EndProcedure
; IDE Options = PureBasic 5.70 LTS (Windows - x64)
; CursorPosition = 37
; FirstLine = 23
; Folding = -
; EnableXP