﻿EnableExplicit

Define i, ret$

Structure PARTITION_INFORMATION_GPT Align #PB_Structure_AlignC
	Partitiontype.GUID
	PartitionId.GUID
	Attributes.q
	Name.b[36]
EndStructure

Structure PARTITION_INFORMATION_MBR Align #PB_Structure_AlignC
	PartitionType.b
	BootIndicator.b
	RecognizedPartition.b
	HiddenSectors.l
EndStructure

Structure DRIVE_LAYOUT_INFORMATION_GPT Align #PB_Structure_AlignC
	PartitionStyle.GUID
	StartingUsableOffset.LARGE_INTEGER
	UsableLength.LARGE_INTEGER
	MaxPartitionCount.l
EndStructure

Structure DRIVE_LAYOUT_INFORMATION_MBR Align #PB_Structure_AlignC
	DiskId.l
	PartitionCount.l
EndStructure

Structure PARTITION_INFORMATION_EX Align #PB_Structure_AlignC
	PartitionStyle.l
	StartingOffset.LARGE_INTEGER
	PartitionLength.LARGE_INTEGER
	PartitionNumber.l
	RewritePartition.b
	StructureUnion
		ppmbr.PARTITION_INFORMATION_MBR
		ppgpt.PARTITION_INFORMATION_GPT
	EndStructureUnion
EndStructure

Structure DRIVE_LAYOUT_INFORMATION_EX Align #PB_Structure_AlignC
	PartitionStyle.l
	PartitionCount.l
	StructureUnion
		pdmbr.DRIVE_LAYOUT_INFORMATION_MBR
		pdgpt.DRIVE_LAYOUT_INFORMATION_GPT
	EndStructureUnion
	PartitionEntry.PARTITION_INFORMATION_EX[255]
EndStructure

; #FILE_ANY_ACCESS = 0
; #FILE_READ_DATA = 1
; #METHOD_BUFFERED = 0
; #IOCTL_DISK_BASE = 7

#PARTITION_STYLE_MBR = 0
#PARTITION_STYLE_GPT = 1
#PARTITION_STYLE_RAW = 2


; Macro CTL_CODE(DeviceType, Function, Method, Access)
; 	((DeviceType)<<16)|((Access)<<14)|((Function)<<2)|(Method)
; EndMacro

#IOCTL_DISK_GET_DRIVE_LAYOUT_EX = $70050

Procedure.s GetPartitionStyle(DiskNumber)
	; 	Protected IOCTL_DISK_GET_DRIVE_LAYOUT_EX = CTL_CODE(#IOCTL_DISK_BASE,$14,#METHOD_BUFFERED,#FILE_ANY_ACCESS)
	Protected pdl.DRIVE_LAYOUT_INFORMATION_EX , result$ = "---", Bytes.l, hDrive
	hDrive = CreateFile_("\\.\PhysicalDrive" + DiskNumber, 0, #FILE_SHARE_READ | #FILE_SHARE_WRITE, 0, #OPEN_EXISTING, 0, 0)
	; hDrive = CreateFile_("\\.\PhysicalDrive" + DiskNumber, #GENERIC_READ, #FILE_SHARE_READ | #FILE_SHARE_WRITE, 0, #OPEN_EXISTING, 0, 0)
	If hDrive <> #INVALID_HANDLE_VALUE
		If DeviceIoControl_(hDrive, #IOCTL_DISK_GET_DRIVE_LAYOUT_EX, 0, 0, @pdl, SizeOf(pdl), @Bytes, 0)
			Select pdl\PartitionStyle
				Case #PARTITION_STYLE_MBR
					result$="MBR"
					
				Case #PARTITION_STYLE_GPT
					result$="GPT"
				Case #PARTITION_STYLE_RAW
					result$="RAW"
			EndSelect
		EndIf
		CloseHandle_(hDrive)
	EndIf
	ProcedureReturn result$
EndProcedure

For i = 0 To 9
	ret$ + "Физ.диск_" + Str(i) + " = " + GetPartitionStyle(i) + #CR$
Next
MessageRequester("Физические диски", ret$)



; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 73
; FirstLine = 53
; Folding = -
; EnableAsm
; EnableXP
; EnableAdmin
; Executable = Является ли диск MBR или GPT v2.exe
; DisableCompileCount = 1
; DisableBuildCount = 1